import QtQuick 2.3

Rectangle {

    Item {
        id: toolBar
        height: 64
        anchors.top: parent.top
        width: parent.width

        Rectangle {
            id: redButton
            anchors.top: parent.top
            anchors.left: parent.left
            height: 64
            width: parent.width / 2
            color: "red"
            MouseArea {
                anchors.fill: redButton
                onClicked: ()=>{
                    mainBody.state = "red"
                }
            }
        }

        Rectangle {
            id: greenButton
            anchors.top: parent.top
            anchors.right: parent.right
            height: 64
            width: parent.width / 2
            color: "green"
            MouseArea {
                anchors.fill: greenButton
                onClicked: ()=>{
                    mainBody.state = "green"
                }
            }
        }
    }

    Item {
        id: mainBody
        anchors.top: toolBar.bottom
        anchors.topMargin: 10
        anchors.bottom: parent.bottom
        width: parent.width
        state: "red"

        Rectangle {
            id: redBlock
            height: mainBody.height
            width: mainBody.width
            color: "red"
            x: 0
        }

        Rectangle {
            id: greenBlock
            height: mainBody.height
            width: mainBody.width
            color: "green"
            x: redBlock.width
            onXChanged: ()=>{
                if (greenBlock.x < 0 || greenBlock.x > greenBlock.width) {
                    console.error("width=" + mainBody.width + " x=" + greenBlock.x)
                }
            }
        }

        states: [
            State {
                name: "red"
                PropertyChanges {
                    target: redBlock
                    x: 0
                }
                PropertyChanges {
                    target: greenBlock
                    x: redBlock.width
                }
            },
            State {
                name: "green"
                PropertyChanges {
                    target: redBlock
                    x: -redBlock.width
                }
                PropertyChanges {
                    target: greenBlock
                    x: 0
                }
            }
        ]
        transitions: [
            Transition {
                NumberAnimation { properties: "x"; easing.type: Easing.OutQuart; duration: 500 }
            }
        ]
    }

}
